## org.mozilla.javascript.ast
Class IfStatement

    java.lang.Object
      org.mozilla.javascript.Node
          org.mozilla.javascript.ast.AstNode
              org.mozilla.javascript.ast.IfStatement

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class IfStatement

extends AstNode

If-else statement. Node type is `Token.IF`.

    IfStatement :
           if ( Expression ) Statement else Statement
           if ( Expression ) Statement

Nested Class Summary

Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode
`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

Nested classes/interfaces inherited from class org.mozilla.javascript.Node
`Node.NodeIterator`

Field Summary

Fields inherited from class org.mozilla.javascript.ast.AstNode
`length, parent, position`

Fields inherited from class org.mozilla.javascript.Node

`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

Constructor Summary
`IfStatement()`
`IfStatement(int pos)`
`IfStatement(int pos, int len)`

Method Summary
`AstNode` `getCondition()` Returns if condition
`AstNode` `getElsePart()` Returns statement to execute if condition is false
`int` `getElsePosition()` Returns position of "else" keyword, or -1
`int` `getLp()` Returns left paren offset
`int` `getRp()` Returns right paren position, -1 if missing
`AstNode` `getThenPart()` Returns statement to execute if condition is true
`void` `setCondition(AstNode condition)` Sets if condition.
`void` `setElsePart(AstNode elsePart)` Sets statement to execute if condition is false
`void` `setElsePosition(int elsePosition)` Sets position of "else" keyword, -1 if not present
`void` `setLp(int lp)` Sets left paren offset
`void` `setParens(int lp, int rp)` Sets both paren positions
`void` `setRp(int rp)` Sets right paren position, -1 if missing
`void` `setThenPart(AstNode thenPart)` Sets statement to execute if condition is true
`java.lang.String` `toSource(int depth)` Emits source code for this node.
`void` `visit(NodeVisitor v)` Visits this node, the condition, the then-part, and if supplied, the else-part.

Methods inherited from class org.mozilla.javascript.ast.AstNode
`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

Methods inherited from class org.mozilla.javascript.Node

`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, setDouble, setJsDoc, setLineno, setScope, setString, setType, toString, toStringTree`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### IfStatement

    public IfStatement()

### IfStatement

    public IfStatement(int pos)

### IfStatement

    public IfStatement(int pos,
                       int len)

Method Detail

### getCondition

    public AstNode getCondition()

  Returns if condition

### setCondition

    public void setCondition(AstNode condition)

  Sets if condition.

  Throws:
    `java.lang.IllegalArgumentException` - if `condition` is `null`.

### getThenPart

    public AstNode getThenPart()

  Returns statement to execute if condition is true

### setThenPart

    public void setThenPart(AstNode thenPart)

  Sets statement to execute if condition is true

  Throws:
    `java.lang.IllegalArgumentException` - if thenPart is `null`

### getElsePart

    public AstNode getElsePart()

  Returns statement to execute if condition is false

### setElsePart

    public void setElsePart(AstNode elsePart)

  Sets statement to execute if condition is false

  Parameters:
    `elsePart` - statement to execute if condition is false. Can be `null`.

### getElsePosition

    public int getElsePosition()

  Returns position of "else" keyword, or -1

### setElsePosition

    public void setElsePosition(int elsePosition)

  Sets position of "else" keyword, -1 if not present

### getLp

    public int getLp()

  Returns left paren offset

### setLp

    public void setLp(int lp)

  Sets left paren offset

### getRp

    public int getRp()

  Returns right paren position, -1 if missing

### setRp

    public void setRp(int rp)

  Sets right paren position, -1 if missing

### setParens

    public void setParens(int lp,
                          int rp)

  Sets both paren positions

### toSource

    public java.lang.String toSource(int depth)

  Description copied from class: `AstNode`
  Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

  Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

  Specified by:
    `toSource` in class `AstNode`
  Parameters:
    `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

### visit

    public void visit(NodeVisitor v)

  Visits this node, the condition, the then-part, and if supplied, the else-part.

  Specified by:
    `visit` in class `AstNode`
  Parameters:
    `v` - the object to call with this node and its children